﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;

namespace AdvBusinessServices
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class CallService:ICallService, IUserProfile
    {
        public AgentScript GetAgentScript(string orderNumber)
        {
            string greeting = DataUtility.GetAgentScript(1);
            AgentScript script = new AgentScript();
            Order order = DataUtility.GetOrderByID(orderNumber);
            Customer customer = DataUtility.GetCustomerByID(order.CustomerID);
            script.CustomerID = customer.CustomerID;
            script.Greeting = string.Format(greeting, customer.LastName);
            script.MinRequiredAnswers = 2;
            script.QuestionList = DataUtility.GetSecurityQuestions(orderNumber);
            return script;
        }

        public OrderInfo GetOrderDetails(string orderNumber)
        {
            OrderInfo oi = new OrderInfo();
            oi.Order = DataUtility.GetOrderByID(orderNumber);
            oi.Customer = DataUtility.GetCustomerByID(oi.Order.CustomerID);
            return oi;
        }


        #region IUserProfile Members

        public User GetUser(string userID)
        {
            return DataUtility.GetUserByID(userID);
        }

        #endregion
    }
}
