﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ClientEntities=AdvClientLibrary.ClientEntities;
using System.Collections.Generic;
using AdvClientLibrary;

namespace AdvCallCenterClient
{
    public class SvcOrderToClientOrder : ClientEntityTranslator
    {
        //singleton
        public static ClientEntityTranslator entityTranslator = new SvcOrderToClientOrder();
        private SvcOrderToClientOrder() { }
        public override ClientEntities.ClientEntity ToClientEntity(object serviceOutputEntity)
        {
            CallBusinessProxy.OrderInfo oi = serviceOutputEntity as CallBusinessProxy.OrderInfo;
            ClientEntities.Order bindableOrder = new ClientEntities.Order();
            bindableOrder.OrderNumber = oi.Order.OrderNumber;
            bindableOrder.OrderTotal = oi.Order.OrderTotal;
            bindableOrder.ShipToAddress = oi.Order.ShipToAddress;
            bindableOrder.Description = oi.Order.Description;
            bindableOrder.CustomerID = oi.Customer.CustomerID;
            return bindableOrder;
        }
    }

    public class SvcUserToClientUser : ClientEntityTranslator
    {
        //singleton
        public static ClientEntityTranslator entityTranslator = new SvcUserToClientUser();
        private SvcUserToClientUser() { }
        public override ClientEntities.ClientEntity ToClientEntity(object serviceOutputEntity)
        {
            ClientEntities.User user = new ClientEntities.User();
            CallBusinessProxy.User _serviceOutputUser = serviceOutputEntity as CallBusinessProxy.User;
            user.Name = _serviceOutputUser.FirstName + " " + _serviceOutputUser.LastName;
            user.RepNumber = _serviceOutputUser.RepNumber;
            user.UserID = _serviceOutputUser.UserID;
            user.Role = _serviceOutputUser.Role;
            user.PhoneExtension = _serviceOutputUser.PhoneExtension;

            return user;
        }
    }

    public class SvcScriptToClientScript     : ClientEntityTranslator
    {
        //singleton
        public static ClientEntityTranslator entityTranslator = new SvcScriptToClientScript();
        private SvcScriptToClientScript(){}
        public override ClientEntities.ClientEntity ToClientEntity(object serviceOutputEntity)
        {
            ClientEntities.AgentScript agentScript = new ClientEntities.AgentScript();
            CallBusinessProxy.AgentScript serviceOutputAgentScript = serviceOutputEntity as CallBusinessProxy.AgentScript;
            agentScript.CustomerID = serviceOutputAgentScript.CustomerID;
            agentScript.Greeting = serviceOutputAgentScript.Greeting;
            agentScript.QuestionList = new List<ClientEntities.SecurityQuestion>();
            foreach (CallBusinessProxy.SecurityQuestion s in serviceOutputAgentScript.QuestionList)
            {
                ClientEntities.SecurityQuestion sc = new ClientEntities.SecurityQuestion();
                sc.Answer = s.Answer;
                sc.AnswerType = s.AnswerType;
                sc.IsAnswered = false;
                sc.Question = s.Question;
                sc.QuestionID = s.QuestionID;
                agentScript.QuestionList.Add(sc);
            }
            return agentScript;
        }
    }
}
