﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace AdvCallCenterClient
{
    public partial class Clock : UserControl
    {
        DispatcherTimer _secondTimer = new DispatcherTimer();
        DateTime _currentTime = DateTime.Now;
        public Clock()
        {
            InitializeComponent();
            _secondTimer.Interval = new TimeSpan(0, 0, 1);
            _secondTimer.Tick += new EventHandler(_timer_Tick);
            _secondTimer.Start();
            RefreshDate();
            RefreshTime();
        }

        void _dayTimer_Tick(object sender, EventArgs e)
        {
            RefreshDate();
        }

        void _timer_Tick(object sender, EventArgs e)
        {
            _currentTime = _currentTime.AddSeconds(1.0);
            RefreshTime();
            if (_currentTime.Hour == 0 && _currentTime.Minute == 0 && _currentTime.Second == 0)
                RefreshDate();
        }
        private void RefreshTime()
        {
            this.tbTime.Text = String.Format("{0:D2}:{1:D2}:{2:D2}", _currentTime.Hour, _currentTime.Minute, _currentTime.Second);
        }
        private void RefreshDate()
        {
            this.tbDate.Text = string.Format(String.Format("{0:D2}/{1:D2}/{2:D4}", _currentTime.Month, _currentTime.Day, _currentTime.Year));
        }
    }
}
