﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AdvCallManager
{
    class PhoneCall
    {
        public string Name;
        public string PhoneNumber;
        public string OrderNumber;
    }

    class CallRep
    {
        public CallRep(RepConnection repCon)
        {
            RepConnection = repCon;
        }
        //encasulates network connection associated with the registered call center rep
        public RepConnection RepConnection { get; set; }
        //uniquely identifies the rep
        public string RepNumber { get; set; }
        public string RepName { get; set; }
        public int PhoneExtension { get; set; }
        public DateTime ShiftStartTime { get; set; }
        public DateTime ShiftEndTime { get; set; }
        //MaxValue indicates haven't rejected any calls
        public DateTime LastRejectTime { get; set; }
        //Available will false if the rep is servicing the call
        public bool Available { get; set; }
        //Locked field will be set to true when a call notification is sent.
        //A background thread will clear it if the rep does not reject or accept 
        //the call notification
        public bool Locked { get; set; }
        //The background thread will use the LockTime + a configurable amount of minutes
        //to free the rep 
        public DateTime LockTime { get; set; }
        public int NoOfCallsServiced; //during the current shift
    }
}