﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using AdvClientLibrary;
using TcpMessages;
using SilverlightPopups;

namespace AdvCallSimulator
{
    public partial class Page : UserControl
    {
        CallNetworkClient _socketClient = new CallNetworkClient();
        OkPopup _popup = null;
        public Page()
        {
            InitializeComponent();
            _socketClient.OnReceive += new EventHandler<ReceiveArgs>(socketClient_OnReceive);
            _socketClient.OnConnectError += new EventHandler<EventArgs>(_socketClient_OnConnectError);
            _socketClient.Connect(4530);
            _popup = new OkPopup(this, "Call is placed in the queue...");
        }

        void _socketClient_OnConnectError(object sender, EventArgs e)
        {
            this.tbStatus.Dispatcher.BeginInvoke(
                delegate()
                {
                    this.tbStatus.Visibility = Visibility.Visible;
                    this.tbStatus.Text = "Connect error..."; 
                }
            );
        }
        void socketClient_OnReceive(object sender, ReceiveArgs e)
        {
            //do some errro handling here
            NetworkMessage msg = e.Result;
            ProcessMessage(msg);
        }
        void ProcessMessage(NetworkMessage msg)
        {
            _popup.CloseDialog();
            //do nothing
        }
        private void btPlaceCall_Click(object sender, RoutedEventArgs e)
        {
            CallMessage msg = new CallMessage(MessageAction.Call);
            msg.CallerName = this.txCustomerName.Text;
            msg.CallerPhone = this.txPhoneNumber.Text;
            msg.IvrData = this.txOrderNumber.Text;
            _socketClient.SendAsync(msg);
            _popup.ShowDialog(true);
        }

    }
}
