﻿using System;
using System.Collections.Generic;

namespace AdvClientLibrary.ClientEntities
{
    //marker entity
    public abstract class ClientEntity { }
    public class PhoneCall:ClientEntity
    {
        public string Name { get; set; }
        public string PhoneNumber { get; set; }
        public string OrderNumber { get; set; }
    }
    public class Order:ClientEntity
    {
        public int CustomerID { get; set; }
        public string OrderNumber { get; set; }
        public string Description { get; set; }
        public double OrderTotal { get; set; }
        public string ShipToAddress { get; set; }
    }

    public class User : ClientEntity
    {
        public string UserID { get; set; }
        public string Name { get; set; }
        public string RepNumber { get; set; }
        public string Role { get; set; }
        public int PhoneExtension { get; set; }
    }

    public class CallRep:ClientEntity
    {
        public DateTime ShiftStartTime { get; set; }
        public DateTime ShiftEndTime { get; set; }
        //MaxValue indicates haven't rejected any calls
        public DateTime LastRejectTime { get; set; }
        //Available will be set to false if a rep accepts the call
        public int NoOfCallsServiced { get; set; } //during the current shift
        public int AverageServiceDuration { get; set; } //average time taken to service a call
    }

    public class AgentScript:ClientEntity
    {
        public int CustomerID { get; set; }
        public string Greeting { get; set; }
        public int MinRequiredAnswers { get; set; }
        public List<SecurityQuestion> QuestionList { get; set; }
    }
    public class SecurityQuestion
    {
        public int QuestionID { get; set; }
        public string Question { get; set; }
        public int AnswerType { get; set; }
        public string Answer { get; set; }
        public bool IsAnswered { get; set; }
    }
}
