﻿using System;
using System.Windows;
using System.Windows.Controls;
using AdvClientLibrary;

namespace SilverlightPopups
{
    public class CommunicationPopup : SLDialogBox
    {
        public event EventHandler<EventArgs> OnCancel;
        public CommunicationPopup(Control parent, string msg)
            : base(parent, msg)
        {

        }
        public override UIElement GetControlTree()
        {
            return ResourceUtility.GetUIElementFromXaml("CommunicationPopup.xaml");
        }
        public override void WireUI()
        {
            FrameworkElement fe = (FrameworkElement)_popup.Child;
            TextBlock btCaption = fe.FindName("tbCaption") as TextBlock;
            if (btCaption != null)
                btCaption.Text = _caption;
        }
        public override void WireHandlers()
        {
            FrameworkElement fe = (FrameworkElement)_popup.Child;
            Button btCancel = (Button)fe.FindName("btCancel");
            btCancel.Click += new RoutedEventHandler(btCancel_Click);
        }

        void btCancel_Click(object sender, RoutedEventArgs e)
        {
            CloseDialog();
            if (OnCancel != null)
            {
                OnCancel(this, null);
            }
            
        }
    }

    public class NotifyCallPopup : SLDialogBox
    {
        public event EventHandler<EventArgs> OnAccept;
        public event EventHandler<EventArgs> OnReject;
        public NotifyCallPopup(Control parent, string msg)
            : base(parent, msg)
        {

        }
        public override UIElement GetControlTree()
        {
            return ResourceUtility.GetUIElementFromXaml("NotifyCallPopup.xaml");
        }
        public override void WireUI()
        {
            FrameworkElement fe = (FrameworkElement)_popup.Child;
            TextBlock btCaption = fe.FindName("tbCaption") as TextBlock;
            if (btCaption != null)
                btCaption.Text = _caption;
        }
        public override void WireHandlers()
        {
            FrameworkElement fe = (FrameworkElement)_popup.Child;
            Button btAccept = (Button)fe.FindName("btAccept");
            btAccept.Click += new RoutedEventHandler(btAccept_Click);

            Button btReject = (Button)fe.FindName("btReject");
            btReject.Click += new RoutedEventHandler(btReject_Click);
      
        }

        void btAccept_Click(object sender, RoutedEventArgs e)
        {
            CloseDialog();
            if (OnAccept != null)
                OnAccept(this, null);
        }
        void btReject_Click(object sender, RoutedEventArgs e)
        {
            CloseDialog();
            if (OnReject != null)
                OnReject(this, null);
        }
    }
    public class OkPopup : SLDialogBox
    {
        public event EventHandler<EventArgs> OnOk;
        public OkPopup(Control parent, string msg)
            : base(parent, msg)
        {

        }
        public override UIElement GetControlTree()
        {
            return ResourceUtility.GetUIElementFromXaml("OkPopup.xaml");
        }
        public override void WireUI()
        {
            FrameworkElement fe = (FrameworkElement)_popup.Child;
            TextBlock btCaption = fe.FindName("tbCaption") as TextBlock;
            if (btCaption != null)
                btCaption.Text = _caption;
        }
        public override void WireHandlers()
        {
            FrameworkElement fe = (FrameworkElement)_popup.Child;
            Button btAccept = (Button)fe.FindName("btOk");
            btAccept.Click += new RoutedEventHandler(btOk_Click);
        }

        void btOk_Click(object sender, RoutedEventArgs e)
        {
            CloseDialog();
            if (OnOk != null)
                OnOk(this, null);
        }
    }
    
}
