﻿//CAUTION:This group of classes will be used on the Silverlight Client also
//so, please make sure of the compatibility at the source code level
using System;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace TcpMessages
{
    class SocketBuffer
    {
        public const int BUFFERSIZE = 1024;
        protected byte[] _buffer;
        protected int _offset = 0;
        public SocketBuffer()
        {
            _buffer = new byte[BUFFERSIZE];
        }
        public SocketBuffer(int size)
        {
            _buffer = new byte[size];
        }
        public byte[] Buffer
        {
            get { return _buffer; }
            set { _buffer = value; }
        }
        //offset will allways indicate the length of the buffer that is filled
        public int Offset
        {
            get {return _offset ;}
            set { _offset = value; }
        }

        public int Remaining
        {
            get { return _buffer.Length - _offset; }
        }
    }

    class PolicyReceiveBuffer : SocketBuffer
    {
        public static readonly string PolicyRequest = "<policy-file-request/>";
        public PolicyReceiveBuffer()
            :base()
        {
        }
        public PolicyReceiveBuffer(int size)
            :base(size)
        {

        }
        public  bool IsMessageReceived()
        {
            string str = Encoding.UTF8.GetString(_buffer, 0, _offset);
            if (string.Compare(PolicyRequest, str, true) == 0)
            {
                return true;
            }
            return false;
        }
    } 
}
